// VictoryInGo.cpp

// By Daniel Rodriguez

#include <algorithm>
#include <iostream>
#include <string>
#include <vector>

using namespace std;


vector<string> I;
bool black, white;
int n;

int dfs(int i, int j){
	if (I[i][j] == 'O') {
		white = true;
		return 0;
	}
	else if (I[i][j] == 'X') {
		black = true;
		return 0;
	}
	else if (I[i][j] == '.') {
		I[i][j] = ',';
		int z = 0;
		if (i > 0) 
			z += dfs(i-1,j);
		if (j > 0) 
			z += dfs(i,j-1);
		if (i < n-1) 
			z += dfs(i+1,j);
		if (j < n-1) 
			z += dfs(i,j+1);
	
		return z+1;
	}
	else
		return 0;
}

int main(){
	int t;
	cin >> t;
	for (;t>0;t--){

		I.clear();
		
		
		string line;
		cin >> line;
		I.push_back(line);
		n = line.length();
		for (int i=1; i<n; i++){
			cin >> line;
			I.push_back(line);
		}


		int whites=0, blacks=0;
		int ws=0, bs=0;
		for (int i=0; i<n; i++) for (int j=0; j<n; j++) {
			if (I[i][j] == 'O') ws++; 
			else if (I[i][j] == 'X') bs++;
			else if (I[i][j] == '.') { 
					black = false; white = false;
					int c = dfs(i,j);
					if (black && !white)
						blacks += c;
					else if (white && !black)
						whites += c;
			}
		}

		cout << "Black " << blacks+bs << " White " << whites+ws << endl;

	}
	return 0;
}