#include<iostream>
#include<vector>
using namespace std;

int countNeighbors(int i, int j, vector<vector<char> > arr) {
	int num = 0;
	if (i-1 >= 0 && arr[i-1][j] == '*') { //Up
		num++;
	}
	if (i+1 < arr.size() && arr[i+1][j] == '*') { //Down
		num++;
	}
	if (j-1 >= 0 && arr[i][j-1] == '*') { //Left
		num++;
	}
	if (j+1 < arr[i].size() && arr[i][j+1] == '*') { //Right
		num++;
	}
	if (i-1 >= 0 && j-1 >= 0 && arr[i-1][j-1] == '*') { //Up left
		num++;
	}
	if (i-1 >= 0 && j+1 < arr[i-1].size()  && arr[i-1][j+1] == '*') { //Up-right
		num++;
	}
	if (i+1 < arr.size() && j-1 > 0 && arr[i+1][j-1] == '*') { //Down left
		num++;
	}
	if (i+1 < arr.size() && j+1 < arr[i+1].size() && arr[i+1][j+1] == '*') { //Down Right
		num++;
	}
	return num;
}

int main() {
	int n, m, count = 0;
	while (cin >> n >> m, n && m) {
		if (count != 0) {
			cout << endl;
		}
		vector<vector<char> > arr;
		for (int x = 0; x < n; x++) {
			vector<char> line;
			for (int y = 0; y < m; y++) {
				char c;
				cin >> c;
				line.push_back(c);
			}
			arr.push_back(line);
		}

		cout << "Field #" << ++count <<  ":" << endl;
		for (int i = 0; i < arr.size(); i++) {
			for (int j = 0; j < arr[i].size(); j++) {
				if (arr[i][j] != '*') {
					int num = countNeighbors(i,j,arr);
					if (arr[i][j] == '.') {
						arr[i][j] = num + '0';
					}
					else {
						arr[i][j] = arr[i][j] + (num + '0');
					}
				}
			}
		}
		for (auto a : arr) {
			for (auto b : a) {
				cout << b;
			}
			cout << endl;
		}
	}
	return 0;
}
			
